# gl_random flip components v0.1
# random batch flip (mirror) componets about center
# gglorenz (at) gmail (dot) com
# 10/2010 

require 'Sketchup.rb'

def gxl_randomflipc

model = Sketchup.active_model
entities = model.entities
selection = model.selection



### dialog #############################################################

defaults = [0, 0, 0]

prompts = [ "x (yes 1 no 0 ) : " , "y (yes 1 no 0 ) : ", "z (yes 1 no 0 ) : "]
results = UI.inputbox prompts, defaults, "Random Scale Parameters"
return nil if not results ### i.e. user cancelled the operation

xflip = results[0]
yflip = results[1]
zflip = results[2]

model.start_operation "randomflipc"

srand #resets random generator

selection.each do |e|
   if (e.is_a? Sketchup::ComponentInstance)
		
		srand 				#resets random generator		
		boundingbox = e.bounds			
		origin = boundingbox.center	# center of object

		if (xflip * rand >= 0.5)  	
			tr = Geom::Transformation.scaling origin, -1, 1, 1
			Sketchup.active_model.entities.transform_entities(tr, e)   
		end #if
		
		if (yflip * rand >= 0.5)  	
			tr = Geom::Transformation.scaling origin, 1, -1, 1
			Sketchup.active_model.entities.transform_entities(tr, e)   
		end #if

		if (zflip * rand >= 0.5)  	
			tr = Geom::Transformation.scaling origin, 1, 1, -1
			Sketchup.active_model.entities.transform_entities(tr, e)   
		end #if

  
end #if
end #do

model.commit_operation

end #main



### Menu ###

if not file_loaded?(__FILE__)

  UI.menu("Plugins").add_item("gxl random flip"){gxl_randomflipc}

end #if


file_loaded(__FILE__)